package guessNumber;

import java.util.Random;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.LongRangeValidator;
import javax.faces.validator.ValidatorException;

import com.sun.faces.util.MessageFactory;

public class UserNumberBean {
	protected int maximum = 0;
	protected boolean maximumSet = false;
	protected String[] status = null;
	protected int minimum = 0;
	protected boolean minimumSet = false;
	protected Integer userNumber = null;
	protected Integer randomInt = null;
	protected String response = null;
	Random randomGR = new Random();
	
	public UserNumberBean() {
		randomInt = new Integer(randomGR.nextInt(10));
		System.out.println("Duke's Number: " + randomInt);
	}
	public void setUserNumber(Integer user_Number) {
		userNumber = user_Number;
		System.out.println("Set userNumber " + userNumber);
	}
	public Integer getUserNumber() {
		System.out.println("get userNumber " + userNumber);
		return userNumber;
	}
	public String getResponse() {
		if (userNumber != null && userNumber.compareTo(randomInt) == 0) {
			randomInt = new Integer(randomGR.nextInt(10));
			return "Yay! You got it!";
		} else {
			return "Sorry, " + userNumber + " is incorrect.";
		}
	}
	public String[] getStatus() {
		return status;
	}
	public void setStatus(String[] newStatus) {
		status = newStatus;
	}
	public int getMaximum() {
		return (this.maximum);
	}
	public void setMaximum(int maximum) {
		this.maximum = maximum;
		this.maximumSet = true;
	}
	public int getMinimum() {
		return (this.minimum);
	}
	public void setMinimum(int minimum) {
		this.minimum = minimum;
		this.minimumSet = true;
	}
	public void validate(FacesContext context, UIComponent component, Object value) throws ValidatorException {
		if ((context == null) || (component == null)) {
			throw new NullPointerException();
		}
		if (value != null) {
			try {
				int converted = intValue(value);
				if (maximumSet &&
						(converted > maximum)) {
					if (minimumSet) {
						throw new ValidatorException(
								MessageFactory.getMessage
								(context, LongRangeValidator.NOT_IN_RANGE_MESSAGE_ID,
										new Object[]{
										new Integer(minimum),
										new Integer(maximum)
								}));
					} else {
						throw new ValidatorException(
								MessageFactory.getMessage
								(context, LongRangeValidator.MAXIMUM_MESSAGE_ID,
										new Object[]{
										new Integer(maximum)
								}));
					}
				}
				if (minimumSet &&
						(converted < minimum)) {
					if (maximumSet) {
						throw new ValidatorException(MessageFactory.getMessage
								(context, LongRangeValidator.NOT_IN_RANGE_MESSAGE_ID,
										new Object[]{
										new Double(minimum),
										new Double(maximum)
								}));
					} else {
						throw new ValidatorException(
								MessageFactory.getMessage
								(context, LongRangeValidator.MINIMUM_MESSAGE_ID,
										new Object[]{
										new Integer(minimum)
								}
								));
					}
				}
			} catch (NumberFormatException e) {
				throw new ValidatorException(
						MessageFactory.getMessage
						(context, LongRangeValidator.TYPE_MESSAGE_ID));
			}
		}
	}
	private int intValue(Object attributeValue)	throws NumberFormatException {
		if (attributeValue instanceof Number) {
			return (((Number) attributeValue).intValue());
		} else {
			return (Integer.parseInt(attributeValue.toString()));
		}
	}
}